(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      6773,        230]
NotebookOptionsPosition[      6073,        205]
NotebookOutlinePosition[      6452,        221]
CellTagsIndexPosition[      6409,        218]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"ClearAll", "[", "\"\<Global`*\>\"", "]"}], ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"koeficientyNakladu", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"100", ",", "0.1", ",", "0.01"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"50", ",", "0.15", ",", "0.015"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"150", ",", "0.08", ",", "0.006"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"minMaxVykony", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"100", ",", "400"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"50", ",", "200"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"200", ",", "1000"}], "}"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.482721896609375*^9, 3.482722028265625*^9}, {
  3.4827221586875*^9, 3.48272216184375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fNaklady", "[", 
    RowBox[{"vykon_", ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_", ",", "c_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"a", "+", 
    RowBox[{"b", "*", "vykon"}], "+", 
    RowBox[{"c", "*", 
     SuperscriptBox["vykon", "2"]}]}]}], ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{"vykony", "=", 
  RowBox[{
   RowBox[{
    SubscriptBox["P", "#"], "&"}], "/@", 
   RowBox[{"Range", "[", "n", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"naklady", "=", 
  RowBox[{"Plus", "@@", 
   RowBox[{"MapThread", "[", 
    RowBox[{"fNaklady", ",", 
     RowBox[{"{", 
      RowBox[{"vykony", ",", "koeficientyNakladu"}], "}"}]}], 
    "]"}]}]}]}], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fOmezeniVykonova", "[", 
    RowBox[{"vykon_", ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"a", "\[LessEqual]", "vykon", "\[LessEqual]", "b"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"omezeniVykonova", "=", 
  RowBox[{"MapThread", "[", 
   RowBox[{"fOmezeniVykonova", ",", 
    RowBox[{"{", 
     RowBox[{"vykony", ",", "minMaxVykony"}], "}"}]}], "]"}]}]}], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vykonCelkemZadany", "=", "500"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"podminkaCelkovehoVykonu", "=", 
  RowBox[{"{", 
   RowBox[{"vykonCelkemZadany", "\[Equal]", 
    RowBox[{"Plus", "@@", "vykony"}]}], "}"}]}]}], "Input"],

Cell[BoxData[
 RowBox[{"podminkyCelkem", "=", 
  RowBox[{"Union", "[", 
   RowBox[{"omezeniVykonova", ",", "podminkaCelkovehoVykonu"}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NMinimize", "[", 
   RowBox[{
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "naklady", "}"}], ",", "podminkyCelkem"}], "]"}], ",", 
    "vykony"}], "]"}], "//", "Timing"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"strmost", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ClearAll", "[", "fPenale", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"fPenale", "[", 
     RowBox[{"x_", ",", 
      RowBox[{"{", 
       RowBox[{"a_", ",", "b_"}], "}"}]}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"2", "+", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Tanh", "[", 
           RowBox[{"strmost", "*", 
            RowBox[{"(", 
             RowBox[{"x", "-", "a"}], ")"}]}], "]"}]}], "+", 
         RowBox[{"Tanh", "[", 
          RowBox[{"strmost", "*", 
           RowBox[{"(", 
            RowBox[{"x", "-", "b"}], ")"}]}], "]"}]}], ")"}]}], ")"}], "*", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"x", "-", 
        RowBox[{"0.5", "*", 
         RowBox[{"(", 
          RowBox[{"a", "+", "b"}], ")"}]}]}], ")"}], "2"]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"fPenale", "[", 
    RowBox[{"x", ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "40"}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "10", ",", "50"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", "Thick"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<x\>\"", ",", "\"\<penale\>\""}], "}"}]}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"penaleCelkovyVykon", "=", 
   RowBox[{"100", "*", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"vykonCelkemZadany", "-", 
       RowBox[{"Plus", "@@", "vykony"}]}], ")"}], "2"]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"penaleVykonovaOmezeni", "=", 
   RowBox[{"Plus", "@@", 
    RowBox[{"MapThread", "[", 
     RowBox[{"fPenale", ",", 
      RowBox[{"{", 
       RowBox[{"vykony", ",", "minMaxVykony"}], "}"}]}], "]"}]}]}], 
  ";"}]}], "Input"],

Cell[BoxData[
 RowBox[{"FminNeomezena", "=", 
  RowBox[{
  "naklady", "+", "penaleCelkovyVykon", "+", 
   "penaleVykonovaOmezeni"}]}]], "Input"],

Cell[BoxData[{
 RowBox[{"startHledani", "=", 
  RowBox[{"minMaxVykony", "/.", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a_", ",", "b_"}], "}"}], "\[RuleDelayed]", 
    FractionBox[
     RowBox[{"a", "+", "b"}], "2."]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"zacatek", "=", 
  RowBox[{"Thread", "[", 
   RowBox[{"{", 
    RowBox[{"vykony", ",", "startHledani"}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Quiet", "@", 
   RowBox[{"FindMinimum", "[", 
    RowBox[{"FminNeomezena", ",", "zacatek"}], "]"}]}], "//", 
  "Timing"}]}], "Input"]
},
WindowSize->{716, 743},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification->1.5000001192092896`,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 94, 2, 43, "Input"],
Cell[654, 24, 850, 25, 152, "Input"],
Cell[1507, 51, 319, 10, 72, "Input"],
Cell[1829, 63, 388, 12, 125, "Input"],
Cell[2220, 77, 468, 13, 125, "Input"],
Cell[2691, 92, 263, 6, 98, "Input"],
Cell[2957, 100, 158, 4, 71, "Input"],
Cell[3118, 106, 230, 7, 71, "Input"],
Cell[3351, 115, 1495, 45, 288, "Input"],
Cell[4849, 162, 507, 16, 126, "Input"],
Cell[5359, 180, 144, 4, 71, "Input"],
Cell[5506, 186, 563, 17, 152, "Input"]
}
]
*)

(* End of internal cache information *)

